#pragma once
#include "BaseObject.h"

namespace Tmpl8 {

	class World;

	class Mario : public BaseObject
	{
	public:
		Mario();

		void Move(World* UseWorld, int FinishedTimer);
		void CheckMarioCollision(World* UseWorld);
		void MarioReset(int Level);
		void FinishAnimation(World* UseWorld, int FinishedTimer);

		void AddMarioSize() { ++MarioSize; }
		void RemoveMarioSize() { --MarioSize; Invincibility = 200; }

		int GetMarioFrame() const { return MarioFrame; }
		int GetMarioSize() const { return MarioSize; }
		bool GetInvincibility() const { return Invincibility; }
		bool GetMarioAlive() const { return MarioAlive; }
		bool GetStar() const { return Star; }

		void SetExitPipe(bool exitPipe) { ExitPipe = exitPipe; }
		void SetMovement(bool Jump, bool Left, bool Right, bool Duck, bool Sprint);
		void SetMarioAlive(bool Alive) { MarioAlive = Alive; }
		void SetMarioSpeedY(int speedY) { SpeedY = speedY; }
		void SetMarioJump(bool Jump) { MarioJump = Jump; }
		void SetMarioJumpEnd(bool JumpEnd) { MarioJumpEnd = JumpEnd; }
		void SetStar() { Star = true; StarTimer = 2000; }

	private:
		int MarioSize;
		int Invincibility;
		int MarioFrame;
		int MarioWalkFrame;
		int MarioWalkTimer;
		int MarioJumpTimer;
		int MarioDeadTimer;
		int FlagTimer;
		int EnterPipeTimer;
		int EnterVPipe;
		int EnterHPipe;
		int StarTimer;
		int StarFrame;

		bool MarioAlive;
		bool MarioFacingLeft;
		bool MarioBoostLeft;
		bool MarioBoostRight;
		bool MarioWalk;
		bool MarioJump;
		bool MarioJumpStart;
		bool MarioJumpEnd;
		bool FlagFrame;
		bool ExitPipe;
		bool VPipe;
		bool HPipe;
		bool Star;

		bool Movement[5];	//Jump, Left, Right, Duck, Sprint
	};

}