#include "precomp.h"
#include "PowerUps.h"
#include "World.h"
#include "Mario.h"

namespace Tmpl8 {

	PowerUps::PowerUps(int x, int y, int type, Mario* UseMario) :
		AnimationTimer(0),
		AnimationFrame(0),
		Timer(1),
		MovingLeft(false),
		Alive(true)
	{
		if (type != 1) Type = type;
		else {
			if (UseMario->GetMarioSize() == 0) Type = 1;
			else Type = 4;
		}
		X = x;
		Y = y;
		SpeedY = 0;
	}

	void PowerUps::Move(World* UseWorld, Mario* UseMario)
	{
		if (AnimationTimer < 80) {
			++AnimationTimer;
			Y -= 1;
		}
		else {
			if (Type != 4) {
				if (SpeedY < 8) SpeedY += 0.3;
				Y += SpeedY;
			}

			switch (Type) {
			case 1: case 2:
				if (MovingLeft) X -= 1;
				else X += 1;
				break;
			case 3:
				break;
			}

			CheckCollision(UseWorld, UseMario);
		}
	}

	int PowerUps::SetFrame()
	{
		if (Type == 3 || Type == 4) {
			if (--Timer == 0) {
				Timer = 10;
				if (++AnimationFrame == 4) AnimationFrame = 0;
			}
		}

		if (!Alive) return -1;
		else {
			switch (Type) {
			case 1:	//Mushroom
				return 0;
				break;
			case 2:	//1-Up
				return 1;
				break;
			case 3:	//Star
				return 2 + AnimationFrame;
				break;
			case 4:	//Fire Flower
				return 6 + AnimationFrame;
				break;
			default:
				return -1;
				break;
			}
		}
	}

	void PowerUps::CheckCollision(World* UseWorld, Mario* UseMario)
	{
		int WorldXOffset = UseWorld->GetWorldXOffset();
		int WorldX = UseWorld->GetWorldX();

		int StartingRow = floor(WorldX / 80) - 10;
		int EndingRow = StartingRow + 16 + 100;
		int BlockX;
		int BlockY;
		int Block;
		int MarioX = UseMario->GetX();
		int MarioY = UseMario->GetY();
		int MarioHeight;
		if (UseMario->GetMarioSize() == 0) {
			MarioY = MarioY - 80;
			MarioHeight = 80;
		}
		else {
			MarioY = MarioY - 160;
			MarioHeight = 160;
		}

		//Check collision with Mario
		if (MarioX < X + 80 && MarioX + 80 > X && MarioY < Y + 80 && MarioY + MarioHeight > Y) {
			if (UseMario->GetMarioAlive()) {
				Alive = false;
				UseWorld->AddScore(1000);
			}
		}
		else if (Type != 4) {
			//Check collision with blocks
			for (int y = 0; y < 13; y++) {
				for (int x = 0; x < 213; x++) {
					if (x >= StartingRow && x <= EndingRow) {

						Block = UseWorld->GetBlock(x, y);

						if (Block > 0) {
							BlockX = (x * 80) - (WorldX - (WorldX % 80) - -WorldXOffset);
							BlockY = y * 80;

							//Check if the enemy even hits a block
							if (X < BlockX + 80 && X + 80 > BlockX && Y < BlockY + 80 && Y + 80 > 80) {

								//top hitbox
								if (X < (BlockX + 10) + 60 && X + 80 >(BlockX + 10) && Y < BlockY && Y + 80 > BlockY) {
									Y = BlockY - 80;
									SpeedY = 0;
								}

								//left hitbox
								else if (X < BlockX && X + 80 > BlockX && Y < (BlockY + 10) + 60 && Y + 80 >(BlockY + 10)) {
									X = BlockX - 80;
									MovingLeft = true;
								}

								//right hitbox
								else if (X < (BlockX + 80) && X + 80 >(BlockX + 80) && Y < (BlockY + 10) + 60 && Y + 80 >(BlockY + 10)) {
									X = BlockX + 80;
									MovingLeft = false;
								}

								//bottom hitbox
								else if (X < (BlockX + 10) + 60 && X + 80 >(BlockX + 10) && Y < (BlockY + 80) && Y + 80 >(BlockY + 80)) {
									Y = BlockY + 80;
									SpeedY = 0;
								}
							}
						}
					}
				}
			}
		}
	}
}