#pragma once

namespace Tmpl8 {

	class Game;
	class Mario;
	class Enemy;
	class Flag;
	class CoinAnimation;
	class PowerUps;

	class World
	{
	public:
		World();	//constructor prototype
		~World();	//deconstructor prototype

		void DrawScreen(Surface* screen, World* UseWorld);
		void DrawScreenBackground(Surface* screen);
		void DrawScreenForeground(Surface* screen);
		void DrawBackground(int x, int y, int StartingRow, int Block, Surface* screen);
		void DrawForeground(int x, int y, int StartingRow, int Block, Surface* screen);
		
		void UpdateAnimationTimer();
		void UpdateScreen();
		void EnterPipe();
		void NextLevel();
		void Reset();
		void CheckEnemy_EnemyCollision();
		void RemoveLife();
		void AddCoin(int x, int y);
		void AddPowerUp(int x, int y, int type);
		void AddScore(int amount) { Score += amount; }
		void DrawNumbers(Surface* screen, int LoadingScreen);

		void SetBlock(int x, int y, int Block);
		int GetBlock(int x, int y) const;

		unsigned char GetLevelFlags() const { return LevelFlags[Level - 1]; }
		bool GetEnemyFrame() const { return EnemyFrame; }
		int GetWorldXOffset() const { return WorldXOffset; }
		int GetWorldX() const { return WorldX; }
		int GetLevel() const { return Level; }

		void SetFinishedTimer() { ++FinishedTimer; }
		void SetFinished(bool finished) { Finished = finished; }

		//Mario
		void SetMovement(bool Jump, bool Left, bool Right, bool Duck, bool Sprint);

	private:
		int Level;
		int WorldX;
		int WorldXOffset;
		int StartingRow;
		int EndingRow;

		//8 = Underground, 4 = Castle, 2 = UnderWater, 1 = Bonus
		unsigned char LevelFlags[7] {0b0000, 0b1001, 0b0000, 0b1000, 0b1001, 0b0000, 0b0100};

		int World1_1[13][213];
		int Bonus1_1[13][16];
		int World1_2[13][53];
		int Underground1_2[13][199];
		int Bonus1_2[13][16];
		int World1_3[13][168];
		int World1_4[13][160];

		int World1_1B[13][213];
		int World1_2B[13][53];
		int World1_3B[13][168];
		int World1_4B[13][160];

		bool EnemyFrame;
		bool Finished;
		int FinishedTimer;
		int LoadingScreenTimer;
		int TimeTimer;

		int QBlockFrame;
		int AnimationTimer;

		int Lives;
		int Coins;
		int Timer;
		int Score;

		Surface* TheSheet;
		Surface* ATile[21][13];
		Surface* TheUndergroundSheet;
		Surface* AnUndergroundTile[21][13];

		Mario* UseMario;
		Enemy* UseEnemy[10];
		Flag* UseFlag;
		CoinAnimation* UseCoinAnimation[5];
		PowerUps* UsePowerUps[5];
	};

}