#include "precomp.h" // include this first in every .cpp file
#include "game.h"
#include "World.h"
#include "Mario.h"
#include "Enemy.h"

namespace Tmpl8
{
	World* UseWorld;

	bool Jump = false;		//all the booleans needed for keyinputs
	bool Left = false;
	bool Right = false;
	bool Duck = false;
	bool Sprint = false;

	void Game::KeyDown(int key)
	{
		switch (key) {
		case 26: case 82: case 27:	//w, up, x
			Jump = true;
			break;
		case 4: case 80:	//a, left
			Left = true;
			break;
		case 7: case 79:	//d, right
			Right = true;
			break;
		case 22: case 81:	//s, down
			Duck = true;
			break;
		case 225: case 29:	//LShift, z
			Sprint = true;
			break;
		}
	}

	void Game::KeyUp(int key)
	{
		switch (key) {
		case 26: case 82: case 27:	//w, up, x
			Jump = false;
			break;
		case 4: case 80:	//a, left
			Left = false;
			break;
		case 7: case 79:	//d, right
			Right = false;
			break;
		case 22: case 81:	//s, down
			Duck = false;
			break;
		case 225: case 29:	//LShift, z
			Sprint = false;
			break;
		}
	}

	void Game::Shutdown()
	{
		delete(UseWorld);
	}

	void Game::Init()
	{
		UseWorld = new World;
	}

	void Game::Tick(float deltaTime)
	{
		unsigned char LevelFlags = UseWorld->GetLevelFlags();
		if (LevelFlags & (1 << 3 | 1 << 2)) screen->Clear(0x000000);
		else if (LevelFlags & 1 << 1) screen->Clear(0x2038EC);
		else screen->Clear(0x5C94FC);

		//printf("%f\n", deltaTime);

		UseWorld->SetMovement(Jump, Left, Right, Duck, Sprint);

		UseWorld->UpdateAnimationTimer();
		UseWorld->UpdateScreen();

		UseWorld->DrawScreen(screen, UseWorld);
	}

};